/*
	Mega644/1284 SD/MMC bootloader for DragonMMC project.
	
	2011-09-19, P.Harvey-Smith.
*/

#define EXIT_KEY	'Q'
#define PROGRAM_KEY	'U'
#define ERASE_KEY	'E'
#define VERSION_KEY	'V'

// Flag values passed back by ProgramAVR()
#define PROGRAM_OK			0
#define INVALID_HEX_LINE	1
#define INVALID_CHECKSUM	2

void EraseAVR(void);
uint8_t ProgramAVR(void);

// Intel hex record types
#define INTEL_DATA_RECORD			0
#define INTEL_EOF_RECORD			1
#define INTEL_EXT_SEG_ADDR_RECORD	2
#define INTEL_START_SEG_ADDR_RECORD	3
#define INTEL_EXT_LIN_ADDR_RECORD	4
#define INTEL_START_LIN_ADDR_RECORD	5

#define LineBufLen	80

// set this to the size of your boot 
#define BOOT_WORDS	4096

#if defined(__AVR_ATmega644__)

  #define sig_byte3 0x1E
  #define sig_byte2 0x96
  #define sig_byte1 0x09
    
  #define APP_PAGES ((2*32768UL / SPM_PAGESIZE)- (2*BOOT_WORDS / SPM_PAGESIZE )) 
  #define APP_END APP_PAGES * SPM_PAGESIZE 

#elif defined(__AVR_ATmega644P__)

  #define sig_byte3 0x1E
  #define sig_byte2 0x96
  #define sig_byte1 0x0A
    
  #define APP_PAGES ((2*32768UL / SPM_PAGESIZE)- (2*BOOT_WORDS / SPM_PAGESIZE )) 
  #define APP_END APP_PAGES * SPM_PAGESIZE 
#else
	#error "no definition for MCU available in bootloader.h"
#endif

