;
; CmdCat.asm
;
; Catalog the MMC.
;

	ifne		Dragon
VarReturnStr	EQU	$8DE1
	else
VarReturnStr	EQU	$B69B
	endc

CmdCat
	bsr		InitDirRead					; Shared by cat and findfirst
	
CmdCatLoop
	lda		#CMD_DIR_READ				; get next entry
	lbsr	MMC_SendCmd
	lbsr	CheckError					; check for errors, returns to basic on error
	
	cmpa	#STATUS_COMPLETE			; Listed all entries ?
	bne		CmdCatPrintNext				; nope : print next entry
		
	clra	
	rts		

CmdCatPrintNext
	lda		#CMD_INIT_READ				; Start reading filename 
	lbsr	MMC_SendCmdRaw
	
CmdCatPrintLoop
	lbsr	MMC_WaitGetWritten			; Wait for byte, and get it in a
	cmpa	#0							; end of filename ?
	beq		CmdCatEOL					; yes : process next name
	
	jsr		BasicScreenOut				; nope print it
	bra		CmdCatPrintLoop

CmdCatEOL
	lbsr	CON_EOL						; send eol
	bra		CmdCatLoop					; do next entry


InitDirRead
	JSR     <BasChrGetCurr				; get current character from command
	beq		InitNullDir

	lbsr	GetSendFileName				; Get path / wildcard 
	bra		InitDirReadOpen				; open the directory
	
; No filename supplied, set a null filename, which also reset wildcard to *
InitNullDir
	lda 	#CMD_INIT_WRITE				; init write, clear dir name
	lbsr	MMC_SendCmd
	lbsr	CheckError					; check for errors, returns to basic on error
	
	lda		#0
	sta		D_WRITE_DATA_REG			; Send null dirname for now
	
InitDirReadOpen
	lda		#CMD_DIR_OPEN				; open dir
	lbsr	MMC_SendCmd
	lbsr	CheckError					; check for errors, returns to basic on error
	rts
	
;
; CmdCWD, change current working directory
;

CmdCWD
	lda		#CMD_DIR_CWD				; change working directory
	lbsr	CmdSendFilenameCmd			; Send directory name and command
	clra	
	rts
	
;
; FuncCWD, return the current working directory as a string.
;

FuncCWD
	lda		#CMD_DIR_GETCWD				; Get current working directory
	lbsr	MMC_SendCmd
	lbsr	CheckError					; check for errors, returns to basic on error

FuncRetMMCString
	lda		#CMD_GET_STRLEN				; get length of returned path
	lbsr	MMC_SendCmdRaw
	lbsr	MMC_WaitGetWritten			; Wait for byte, and get it in a

FuncRetMMCStringLenA
	tfr		a,b							; move length to b
	pshs	a
	JSR     >BasResStr					; reserve string space, exits with OS error if no space
										; X points to string
	puls	b							; recover length
	tstb								; check for zero length string
	beq		FuncRetMMCStringExit		; yes don't copy anything
	
	lda		#CMD_INIT_READ				; Start reading filename 
	lbsr	MMC_SendCmdRaw

FuncCWDLoop
	lbsr	MMC_WaitGetWritten			; Wait for byte, and get it in a
	sta		,x+
	decb								; decrement count
	bne		FuncCWDLoop					; more : keep going
	
FuncRetMMCStringExit
	JMP		VarReturnStr				; return string to basic.
	
;
; Find first file
;

FuncFindFirst
	bsr		InitDirRead					; Shared by cat and findfirst

FuncFindNext
	lda		#CMD_DIR_READ				; get next entry
	lbsr	MMC_SendCmd
	lbsr	CheckError					; check for errors, returns to basic on error
	
	cmpa	#STATUS_COMPLETE			; Listed all entries ?
	beq		FindEnd
	bra		FuncRetMMCString			; return filename to basic
	
FindEnd
	clra								; return no bytes
	bra		FuncRetMMCStringLenA
	
