;
; BasicTokens.asm
;
; Values for Dragon and CoCo basic tokens.
;

;
; Dragon Commands
;

DTokFOR		EQU	$80
DTokGO		EQU	$81
DTokREM		EQU	$82
DTokREMComma	EQU	$83
DTokELSE	EQU	$84
DTokIF		EQU	$85
DTokDATA	EQU	$86
DTokPRINT	EQU	$87
DTokON		EQU	$88
DTokINPUT	EQU	$89
DTokEND		EQU	$8A
DTokNEXT	EQU	$8B
DTokDIM		EQU	$8C
DTokREAD	EQU	$8D
DTokLET		EQU	$8E
DTokRUN		EQU	$8F
DTokRESTORE	EQU	$90
DTokRETURN	EQU	$91
DTokSTOP	EQU	$92
DTokPOKE	EQU	$93
DTokCONT	EQU	$94
DTokLIST	EQU	$95
DTokCLEAR	EQU	$96
DTokNEW		EQU	$97
DTokDEF		EQU	$98
DTokCLOAD	EQU	$99
DTokCSAVE	EQU	$9A
DTokOPEN	EQU	$9B
DTokCLOSE	EQU	$9C
DTokLLIST	EQU	$9D
DTokSET		EQU	$9E
DTokRESET	EQU	$9F
DTokCLS		EQU	$A0
DTokMOTOR	EQU	$A1
DTokSOUND	EQU	$A2
DTokAUDIO	EQU	$A3
DTokEXEC	EQU	$A4
DTokSKIPF	EQU	$A5
DTokDELETE	EQU	$A6
DTokEDIT	EQU	$A7
DTokTRON	EQU	$A8
DTokTROFF	EQU	$A9
DTokLINE	EQU	$AA
DTokPCLS	EQU	$AB
DTokPSET	EQU	$AC
DTokPRESET	EQU	$AD
DTokSCREEN	EQU	$AE
DTokPCLEAR	EQU	$AF
DTokCOLOR	EQU	$B0
DTokCIRCLE	EQU	$B1
DTokPAINT	EQU	$B2
DTokGET		EQU	$B3
DTokPUT		EQU	$B4
DTokDRAW	EQU	$B5
DTokPCOPY	EQU	$B6
DTokPMODE	EQU	$B7
DTokPLAY	EQU	$B8
DTokDLOAD	EQU	$B9
DTokRENUM	EQU	$BA
DTokTAB		EQU	$BB
DTokTO		EQU	$BC
DTokSUB		EQU	$BD
DTokFN		EQU	$BE
DTokTHEN	EQU	$BF
DTokNOT		EQU	$C0
DTokSTEP	EQU	$C1
DTokOFF		EQU	$C2
DTokPLUS	EQU	$C3
DTokMINUS	EQU	$C4
DTokTIMES	EQU	$C5
DTokDIVIDE	EQU	$C6
DTokAT		EQU	$C7
DTokAND		EQU	$C8
DTokOR		EQU	$C9
DTokGREATER	EQU	$CA
DTokEQUAL	EQU	$CB
DTokLESS	EQU	$CC
DTokUSING	EQU	$CD

DBTokFirstC	EQU	DTokFOR
DBTokLastC	EQU	DTokUSING

;
; Dragon Functions
; Tokens are preceeded by $FF
;

DTokSGN		EQU	$80
DTokINT		EQU	$81
DTokABS		EQU	$82
DTokPOS		EQU	$83
DTokRND		EQU	$84
DTokSQR		EQU	$85
DTokLOG		EQU	$86
DTokEXP		EQU	$87
DTokSIN		EQU	$88
DTokCOS		EQU	$89
DTokTAN		EQU	$8A
DTokATN		EQU	$8B
DTokPEEK	EQU	$8C
DTokLEN		EQU	$8D
DTokSTRS	EQU	$8E
DTokVAL		EQU	$8F
DTokASC		EQU	$90
DTokCHRS	EQU	$91
DTokEOF		EQU	$92
DTokJOYSTK	EQU	$93
DTokFIX		EQU	$94
DTokHEXS	EQU	$95
DTokLEFTS	EQU	$96
DTokRIGHTS	EQU	$97
DTokMIDS	EQU	$98
DTokPOINT	EQU	$99
DTokINKEYS	EQU	$9A
DTokMEM		EQU	$9B
DTokVARPTR	EQU	$9C
DTokINSTR	EQU	$9D
DTokTIMER	EQU	$9E
DTokPPOINT	EQU	$9F
DTokSTRINGS	EQU	$A0
DTokUSR		EQU	$A1

DBTokFirstF	EQU	DTokSGN
DBTokLastF	EQU	DTokUSR

;
; DragonDOS / SuperDOS command tokens
;

DDTokAUTO	EQU	$CE	
DDTokBACKUP	EQU	$CE
DDTokBEEP	EQU	$D0
DDTokBOOT	EQU	$D1
DDTokCHAIN	EQU	$D2
DDTokCOPY	EQU	$D3
DDTokCREATE	EQU	$D4
DDTokDIR	EQU	$D5
DDTokDRIVE	EQU	$D6
DDTokDSKINIT	EQU	$D7
DDTokFREAD	EQU	$D8
DDTokFWRITE	EQU	$D9
DDTokERROR	EQU	$DA
DDTokKILL	EQU	$DB
DDTokLOAD	EQU	$DC
DDTokMERGE	EQU	$DD
DDTokPROTECT	EQU	$DE
DDTokWAIT	EQU	$DF
DDTokRENAME	EQU	$E0
DDTokSAVE	EQU	$E1
DDTokSREAD	EQU	$E2
DDTokSWRITE	EQU	$E3
DDTokVERIFY	EQU	$E4
DDTokFROM	EQU	$E5
DDTokFLREAD	EQU	$E6
DDTokSWAP	EQU	$E7

DDTokFirstC	EQU	DDTokAUTO	; First + Last Dragondos command Token
DDTokLastC	EQU	DDTokSWAP
DDTokCountC	EQU	(DDTokLastC-DDTokFirstC)+1
;
; DragonDOS / SuperDOS function tokens
;

DDTokLOF	EQU	$A2
DDTokFREE	EQU	$A3
DDTokERL	EQU	$A4
DDTokERR	EQU	$A5
DDTokHIMEM	EQU	$A6
DDTokLOC	EQU	$A7
DDTokFRES	EQU	$A8

DDTokFirstF	EQU	DDTokLOF	; First + Last Dragondos function Token
DDTokLastF	EQU	DDTokFRES
DDTokCountF	EQU	(DDTokLastF-DDTokFirstF)+1

; CoCo 1/2 Commands
;

CTokFOR		EQU	$80
CTokGO		EQU	$81
CTokREM		EQU	$82
CTokREMComma	EQU	$83
CTokELSE	EQU	$84
CTokIF		EQU	$85
CTokDATA	EQU	$86
CTokPRINT	EQU	$87
CTokON		EQU	$88
CTokINPUT	EQU	$89
CTokEND		EQU	$8A
CTokNEXT	EQU	$8B
CTokDIM		EQU	$8C
CTokREAD	EQU	$8D
CTokLET		EQU	$BA
CTokRUN		EQU	$8E
CTokRESTORE	EQU	$8F
CTokRETURN	EQU	$90
CTokSTOP	EQU	$91
CTokPOKE	EQU	$92
CTokCONT	EQU	$93
CTokLIST	EQU	$94
CTokCLEAR	EQU	$95
CTokNEW		EQU	$96
CTokDEF		EQU	$B9
CTokCLOAD	EQU	$97
CTokCSAVE	EQU	$98
CTokOPEN	EQU	$99
CTokCLOSE	EQU	$9A
CTokLLIST	EQU	$9B
CTokSET		EQU	$9C
CTokRESET	EQU	$9D
CTokCLS		EQU	$9E
CTokMOTOR	EQU	$9F
CTokSOUND	EQU	$A0
CTokAUDIO	EQU	$A1
CTokEXEC	EQU	$A2
CTokSKIPF	EQU	$A3
CTokDELETE	EQU	$B5
CTokEDIT	EQU	$B6
CTokTRON	EQU	$B7
CTokTROFF	EQU	$B8
CTokLINE	EQU	$BB
CTokPCLS	EQU	$BC
CTokPSET	EQU	$BD
CTokPRESET	EQU	$BE
CTokSCREEN	EQU	$BF
CTokPCLEAR	EQU	$C0
CTokCOLOR	EQU	$C1
CTokCIRCLE	EQU	$C2
CTokPAINT	EQU	$C3
CTokGET		EQU	$C4
CTokPUT		EQU	$C5
CTokDRAW	EQU	$C6
CTokPCOPY	EQU	$C7
CTokPMODE	EQU	$C8
CTokPLAY	EQU	$C9
CTokDLOAD	EQU	$CA
CTokRENUM	EQU	$CB
CTokTAB		EQU	$A4
CTokTO		EQU	$A5
CTokSUB		EQU	$A6
CTokFN		EQU	$CC
CTokTHEN	EQU	$A7
CTokNOT		EQU	$A8
CTokSTEP	EQU	$A9
CTokOFF		EQU	$AA
CTokPLUS	EQU	$AB
CTokMINUS	EQU	$AC
CTokTIMES	EQU	$AD
CTokDIVIDE	EQU	$AE
CTokAT		EQU	$AF
CTokAND		EQU	$B0
CTokOR		EQU	$B1
CTokGREATER	EQU	$B2
CTokEQUAL	EQU	$B3
CTokLESS	EQU	$B4
CTokUSING	EQU	$CD

CBTokFirstC	EQU	CTokFOR
CBTokLastC	EQU	CTokUSING

;
; CoCo 1/2 Functions
; Tokens are preceeded by $FF
;

CTokSGN		EQU	$80
CTokINT		EQU	$81
CTokABS		EQU	$82
CTokPOS		EQU	$9A
CTokRND		EQU	$84
CTokSQR		EQU	$9B
CTokLOG		EQU	$99
CTokEXP		EQU	$97
CTokSIN		EQU	$85
CTokCOS		EQU	$95
CTokTAN		EQU	$96
CTokATN		EQU	$94
CTokPEEK	EQU	$86
CTokLEN		EQU	$87
CTokSTRS	EQU	$88
CTokVAL		EQU	$89
CTokASC		EQU	$8A
CTokCHRS	EQU	$8B
CTokEOF		EQU	$8C
CTokJOYSTK	EQU	$8D
CTokFIX		EQU	$98
CTokHEXS	EQU	$9C
CTokLEFTS	EQU	$8E
CTokRIGHTS	EQU	$8F
CTokMIDS	EQU	$90
CTokPOINT	EQU	$91
CTokINKEYS	EQU	$92
CTokMEM		EQU	$93
CTokVARPTR	EQU	$9D
CTokINSTR	EQU	$9E
CTokTIMER	EQU	$9F
CTokPPOINT	EQU	$A0
CTokSTRINGS	EQU	$A1
CTokUSR		EQU	$83

CBTokFirstF	EQU	DTokSGN
CBTokLastF	EQU	DTokUSR

;
; CoCo RS-DOS command tokens
;

CDTokDIR	EQU	$CE
CDTokDRIVE	EQU	$CF
CDTokFIELD	EQU	$D0
CDTokFILES	EQU	$D1
CDTokKILL	EQU	$D2
CDTokLOAD	EQU	$D3
CDTokLSET	EQU	$D4
CDTokMERGE	EQU	$D5
CDTokRENAME	EQU	$D6
CDTokRSET	EQU	$D7
CDTokSAVE	EQU	$D8
CDTokWRITE	EQU	$D9
CDTokVERIFY	EQU	$DA
CDTokUNLOAD	EQU	$DB
CDTokDSKINI	EQU	$DC
CDTokBACKUP	EQU	$DD
CDTokCOPY	EQU	$DE
CDTokDISKIS	EQU	$DF
CDTokDISKOS	EQU	$E0

CDTokFirstC	EQU	CDTokDIR	; First RS-DOS command Token

;
; CoCo RS-DOS function tokens
;

CDTokCVN	EQU	$A2
CDTokFREE	EQU	$A3
CDTokLOC	EQU	$A4
CDTokLOF	EQU	$A5
CDTokMKNS	EQU	$A6

CDTokFirstF	EQU	CDTokDIR	; First RS-DOS function Token

