;
; Utility routines
;

;
; wrapper for UtilCopyBXtoU, that disables interrupts whilst doing it's work
; 

DO_SafeCopy
		pshs	cc						; save condition codes
		orcc	#FlagIRQ+FlagFIRQ		; disable ints
		jsr		UtilCopyBXtoU			; do the copy
		puls	cc,pc					; restore and return
		
;
; Wrapper for UtilCopyBXtoU which enables extra ram before copying, and disables afterwards
; this assumes that the roms have already been mirrored to ram, and is to be used
; for copying data to ram e.g. whilst snapshotting.
;
		
DO_RamCopy
		pshs	a,cc					; save condition codes
		orcc	#FlagIRQ+FlagFIRQ		; disable ints
		lda		#D_RAM_ENABLE			; put us in ram mode
		sta		D_RAM_CTRL				; set flags
		jsr		UtilCopyBXtoU			; do the copy
		clr		D_RAM_CTRL				; back to rom mode
		puls	a,cc,pc					; restore and return
