;
; CmdsRam	: Ram copy related commands.
;



;
; Copy Dragon ROM from $8000-$FEFF to ram.
;
CmdRamBoot
		clr		D_RAM_CTRL				; make sure we are in ROM mode, ram write enabled
		ldx		#$8000					; point at base of system ROM
RamBootLoop
		ldd		,X						; get a word
		std		,x++					; put it in ram, writes always go to ram
		cmpx	#$FF00					; done all
		blo		RamBootLoop				; nope, do next
		
		lda		#D_RAM_ENABLE			; enable RAM
		sta		D_RAM_CTRL				; put us in ram mode.
		clra							; no error
		rts

;
; Copy Dragon rom to ram and patch for cassette emulation on mmc
;

CmdMCas
		tsta
		beq		CmdMCasNormal
		JSR     <BasChrGet				; skip the charcter
		
CmdMcasWrite
		lda		#D_RAM_ENABLE			; Leave it write enabled
		bra		CmdMcasGo
		
CmdMCasNormal
		lda		#D_RAM_ENABLE+D_RAM_WP	; put us in ram mode, write protected.
CmdMcasGo		
		pshs	a
		
		bsr		CmdRamBoot				; Switch to all ram mode
		ldx		#CasPatch				; pointe to patches
CmdMCasNext
		ldy		,x++					; Get address to patch
		beq		CmdMCasPatchDone 		; address=0, end
	
		ldb		,x+						; Byte count
CmdMCasPLoop
		lda		,x+						; Get a byte
		sta		,y+						; Put in ram
		decb							; Decrement count
		bne		CmdMCasPLoop
		bra		CmdMCasNext				; Do next patch
	
CmdMCasPatchDone
		puls	a						; recover ram flag
		sta		D_RAM_CTRL
			
CmdMCasExit	
		rts


;*****************************
; Patches to rom fo CmdMcas. *
;*****************************

CasPatch
		FDB	$BDED				; Address
		FCB	CasP1E-CasP1		; length

; Patch wait for leader to just return
CasP1
		rts						; Bytes to patch
CasP1E


		FDB	$BDAD				; Address
		FCB	CasP2E-CasP2		; length

; Patch byte in to read a byte from the MMC
CasP2
		JMP	>MMC_ReadFByte	
CasP2E	


		FDB	$B945				; Address
		FCB	CasP3E-CasP3		; length

; Patch byte in to read a byte from MMC
CasP3
		JSR		>MMC_ReadFByte	
		NOP
CasP3E

		FDB	$B961				; Address
		FCB	CasP4E-CasP4		; length

; Patch byte in to read a block from the MMC
CasP4
		nop
		nop
		jmp		>MMC_ReadFBlock	;Read block
CasP4E


		FDB	$be12				; Address
		FCB	CasP5E-CasP5		; length

; Patch write a byte to the MMC
CasP5
		JMP		>MMC_writeFByte	
CasP5E


;
; Patch the write byte loop in the CasBlockOut to use a multi-byte write file.
;

		fdb	$b9c1
		FCB	CasP6E-CasP6		; length

; Patch write a byte to the MMC
CasP6
		JMP		>MMC_WriteFBlock
		nop
CasP6E

;
; Patch the gap checking routine to not toggle the cassette relay.
;

;		fdb	$b906
;		fcb	CasP7E-CasP7		; length
;
;CasP7
;		fcb	$21					; code for BRN
;CasP7E

;
; Patch motor on to just return, without turning on motor.
;

		fdb	CasMotorOn
		fcb	CasP8E-CasP8		; length

CasP8
		rts
CasP8E

;*****************************************************************
;******************[ End of Patches ]*****************************
;*****************************************************************
		FDB	$0000			; end of patches
