*
* Deinitions for ROM entry points and low memory variables on Dragon 
* 32/64/Alpha.
*
* 2005-11-10. P.Harvey-Smith.
*

;
; Low memory vars in page 0 and 1
;

BasTextPtr	EQU		$19		; Basic text pointer
BasVarsPtr	EQU		$1B		; Pointer to start of vars
BasArrayPtr	EQU		$1D		; Pointer to start of arrays
BasEndInUse	EQU		$1F		; End of storage in use

BasFACExponent	EQU		$4F		; Floating point accumulator exponent
BasFACMantissa	EQU		$50		; FAC mantissa (4 bytes)
BasStrAddr	EQU		$52		; Address of string argument 
BasFACManSgn	EQU		$54		; Sign of mantissa
BasFACManSTemp	EQU		$55		; Tempory sign of mantissa

BasDeviceNo	EQU		$6F		; Current device number
ResetVecAddr	EQU		$72		; Reset vector address, points to a NOP
Zero16Bit	EQU		$8A		; 16 bit zero
BasUsrBasePtr	EQU		$B0		; Pointer to base of usr vectors
GrfTopPtr	EQU		$B7		; Pointer to top of graphics screen
GrfBasePtr	EQU		$BA		; Graphics area base pointer

BasJoyRX	EQU		$15A		; Basic, Right Joystick X
BasJoyRY	EQU		$15B		; Basic, Right Joystick Y
BasJoyLX	EQU		$15C		; Basic, Left Joystick X
BasJoyLY	EQU		$15D		; Basic, Left Joystick Y
RamHooks	EQU		$15E		; Begining of ram hooks (see below)

StubResWordsOfs		EQU	$0000		Offset of number of reserved words
StubResLookupOfs	EQU	$0001		Offset of reserved word lookup table
StubResJumpOfs		EQU	$0003		Offset of reserved word jump table
StubFuncsOfs		EQU	$0005		Offset of nummber of functions
StubFuncsLookupOfs	EQU	$0006		Offset of function lookup table
StubFuncsJumpOfs	EQU	$0008		Offset of functions jump table

Skip1			EQU	$0021		Skip 1 byte (BRN)
Skip2			EQU	$008C		Skip 2 bytes (CMPX)
Skip1LD			EQU	$0086		Skip 1 byte (LDA)
Skip2TST		EQU	$007D		Skip 2 bytes (TST)
Skip2LDX		EQU	$008E		Skip 2 bytes (LDX)

CoCoVec167		EQU	$0000		Vector dest for 167 
CoCoVect16A		EQU	$0000		Vector dest for 16A
CoCoVect176		EQU	$0000		Vector dest for 176
CoCoVect179		EQU	$0000		Vector dest for 179
CoCoVect18B		EQU	$0000		Vector dest for 18B
CoCoVect191		EQU	$0000		Vector dest for 191
CoCoVect194		EQU	$0000		Vector Dest for 194
CoCoVect197		EQU	$0000		Vector Dest for 197
CoCoVect19A		EQU	$0000		Vector Dest for 19A
CoCoVect1A3		EQU	$0000		Vector Dest for 1A3
SerDLTimeout		EQU	$0000		Timeourt for DLOAD, unknown for Dragon
SerDLBaud		EQU	$0000		Baud rate for DLOAD, unknown for Dragon
BasBreakFlag		EQU	$0000		Break flag, +ve=stop,-ve=end
BasDelim1		EQU	$0001		First string delimiter
BasDelim2		EQU	$0002		Second string delimiter
BasGenCount		EQU	$0003		General count/scratch var
BasIfCount		EQU	$0004		If count - how many in a line
BasArrayEval		EQU	$0005		Array evaluation flag, 0=eval, 1=dimensioning
BasVarType		EQU	$0006		Variable type flag 0=numeric, $ff=string
BasGarbageFlag		EQU	$0007		Garbage collection flag
BasDisArraySearch	EQU	$0008		Disable array search flag, 0=allow 0<>disable
BasInputFlag		EQU	$0009		Iinput/read flag, 0=input 0<>read
BasRelateFlag		EQU	$000A		Relational operator flag
BasStrFirstFreeTemp	EQU	$000B		First free temory string space pointer
BasStrLastUsedTemp	EQU	$000D		Last used tempory string space pointer
BasTempPtr		EQU	$000F		Tempory pointer
BasTempPtr1		EQU	$0011		Tempory discriptor pointer (stack search)
BasTempFPA2		EQU	$0013		Tempory FPA Mantissa for FPA2
BasBotStack		EQU	$0017		Bottom of stack at last check
BasStartProg		EQU	$0019		Start addr of basic program
BasVarSimpleAddr	EQU	$001B		Start address of simple variables
BasVarArrayAddr		EQU	$001D		Start address of Array table
BasVarEnd		EQU	$001F		End of storage in use by basic
BasVarStringBase	EQU	$0021		Base address of string space (and stack)
AddrStack		EQU	$0021		Address of top of machine stack
BasVarStrTop		EQU	$0023		Top of string space in use
BasStrUtil		EQU	$0025		Utility string pointer
AddrFWareRamTop		EQU	$0027		Top of firmware RAM CLEAR xxx,yyyy set this to yyyy
BasContLine		EQU	$0029		Line no used by CONT
BasTempLine		EQU	$002B		Tempory line no
BasOldInputPtr		EQU	$002D		Pointer to saved input during a STOP
BasDirectTextPtr	EQU	$002F		Direct mode text pointer
BasVarDataLine		EQU	$0031		Line number of current data statement
BasVarDataAddr		EQU	$0033		Address of next item in data
TextKbdBuffAddr		EQU	$0035		Address of keyboard input buffer
BasVarLastInUse		EQU	$0037		Pointer to variable last in use
BasVarPtrLast		EQU	$0039		Poiinter to VARPTR last in use
BasTempVarDesc		EQU	$003B		Pointer to a tempory var descriptor
BasTempRelateFlag	EQU	$003F		Tempory relational operator flag
BasVarFPAcc3		EQU	$0040		Floating point accumulator 3 (packed)
BasVarFPAcc4		EQU	$0045		Floating point accumulator 4 (packed)
BasVarFPAcc5		EQU	$004A		Floating point accumulator 5 (packed)
BasVarFPAcc1		EQU	$004F		Floating point acumulator 1
BasVarAssign16		EQU	$0052		Part of FPA1, used for 16bit assigns
BasVarFPAcc2		EQU	$005C		Floating point acumulator 2
BasListLine		EQU	$0066		Current line during list
BasCurrentLine		EQU	$0068		Current line no $FFFF in direct mode
TextVDUCommaW		EQU	$006A		VDU comma width field
TextVDULastComma	EQU	$006B		VDU last comma field, should be VDU line width - VDU comma width
TextVDUCurrCol		EQU	$006C		Current column for VDU output
TextVDULineW		EQU	$006D		VDU line width, normally 32
CasIOFlag		EQU	$006E		Cassette IO Flag, set to $FF when IO in progress
TextDevN		EQU	$006F		Current device number
CasEOFFlag		EQU	$0070		Cassette IO Flag, nonzero if EOF reached
WarmStartFlag		EQU	$0071		Warm start flag $55=warm start, else cold start
IndVecReset		EQU	$0072		Secondary Reset vector address, must point to NOP
AddrRamTop		EQU	$0074		Physical end of RAM (4K, 16K, 32K or 64K).
BasUnused1		EQU	$0076		2 unused bytes
CasStatus		EQU	$0078		Cassette status byte, 0=cassette closed, 1=open for input, 2=open for output
CasIOBuffSize		EQU	$0079		Size of cassette IO buffer
CasHeadBuffAddr		EQU	$007A		Address of cassette file header
CasBlockType		EQU	$007C		Cassete block type, 0=filename, 1=data, 255=EOF
CasBlockLen		EQU	$007D		Cassete block length, number of bytes read, or to be written
CasIOBuffAddr		EQU	$007E		Cassette IO buffer address, where data will be read/written
CasCkSum		EQU	$0080		Used by cassette routines for calculating checksum
CasIOErrorCode		EQU	$0081		Cassette IO error code 0=no error, 1=CRC, 2=attempt to load in non-ram area
CasTemp			EQU	$0082		Cassette tempory storage
CasBitCount		EQU	$0083		Cassette bit counter
CasPhaseFlag		EQU	$0084		Cassette Phase flag
CasLastSine		EQU	$0085		Casette last sine tabe entry
GrSetResetData		EQU	$0086		Data for Lo-res set/reset
TextLastKey		EQU	$0087		ASCII code of last keypress, not cleard by key release
TextVDUCursAddr		EQU	$0088		Current VDU cursor address
Misc16BitScratch	EQU	$008A		Misc 16 bit scratch register (always zero ??)
SndPitch		EQU	$008C		Sound pitch value
SndLength		EQU	$008D		Sound duration
TextCursFalshCnt	EQU	$008F		Cusrsor flash counter
CasLeadCount		EQU	$0090		Cassete leader count, number of $55 bytes in the leader
CasPartrt		EQU	$0092		Cassette 1200/2400 partition
CasMax12		EQU	$0093		Cassette Upper limit of 1200Hz
CasMax24		EQU	$0094		Cassette Upper limit of 2400Hz
CasMotorDelay		EQU	$0095		Cassette motor on delay (also inter-block gap)
TextKbdDelay		EQU	$0097		Keyboard scan delay constant, used to debounce
TextPrnCommaW		EQU	$0099		Printer comma width
TextPrnLastComma	EQU	$009A		Printer last comma width, should be printer line width - prinnter comma width
TextPrnLineW		EQU	$009B		Printer line width
TextPrnCurrCol		EQU	$009C		Printer current column
BasExecAddr		EQU	$009D		Exec address, on D64, at startup points to routine to boot all ram mode
BasChrGet		EQU	$009F		Get next basic character routine
BasChrGetCurr		EQU	$00A5		Get current basic ccharacter
BasAddrSigByte		EQU	$00A6		Address of current significant bit in command line
BasRndData		EQU	$00AB		Used by RND
BasTronFlag		EQU	$00AF		Tron flag nonzero=trace on
BasUSRTableAddr		EQU	$00B0		Address of USR address table
GrForeground		EQU	$00B2		Current foreground colour
GrBackground		EQU	$00B3		Current background colour
GrColourTemp		EQU	$00B4		Tempory colour in use
GrCurrColour		EQU	$00B5		Byte value for current colour, to set all pixels in byte to that colour
GrCurrPmode		EQU	$00B6		Current PMODE number
GrLastDisplayAddr	EQU	$00B7		Address of last byte in current display
GrBytesPerLine		EQU	$00B9		Number of byts/lin in current mode
GrDisplayStartAddr	EQU	$00BA		Address of first byte in current display
GrStartPages		EQU	$00BC		Page number of Start of graphics pages
GrCurrX			EQU	$00BD		Current X cursor pos
GrCurrY			EQU	$00BF		Current Y cursor pos
GrColourSet		EQU	$00C1		Colour set currently in use
GrPlotFlag		EQU	$00C2		Plot/Unplot flag, 0=reset, nonzero=set
GrPixelNoX		EQU	$00C3		Current horizontal pixel no
GrPixelNoY		EQU	$00C5		Current vertical pixel number
GrCurrXCo		EQU	$00C7		Current Cursor X
GrCurrYCo		EQU	$00C9		Current Cursor Y
GrCircleXCo		EQU	$00CB		Circle command X
GrCircleYCo		EQU	$00CD		Circle command Y
BasRenumVal		EQU	$00CF		Renum increment value
GrCircleRadius		EQU	$00D0		Circle radius
BasRenumStart		EQU	$00D1		Renum start line no
BasCloadMOffs		EQU	$00D3		2s complement of CLOADM offset
BasRenumStartLine	EQU	$00D5		Renum start line number
BasEditorLineLen	EQU	$00D7		Editor line length
GrDirtyFlag		EQU	$00DB		Flag to tell if graphics screen has changed
SndOctave		EQU	$00DE		Sound octave value for PLAY
SndVolume		EQU	$00DF		Sound volume for PLAY
SndNoteLen		EQU	$00E1		Note length for PLAY
SndTempo		EQU	$00E2		Tempo for PLAY
SndTimerPlay		EQU	$00E3		Timer for the Play command
SndDotNoteScale		EQU	$00E5		Dotted note scale factor for Play
GrDrawAngle		EQU	$00E8		Current angle for DRAW command
GrDrawScale		EQU	$00E9		Current scale for DRAW command
SecVecSWI3		EQU	$0100		Secondary SWI3 vector JMP+ address
SecVecSWI2		EQU	$0103		Secondary SWI2 vector JMP+ address
SecVecSWI		EQU	$0106		Secondary NMI vector JMP+ address
SecVecNMI		EQU	$0109		Secondary NMI vector JMP+ address
SecVecIRQ		EQU	$010C		Secondary IRQ vector JMP+ address
SecVecFIRQ		EQU	$010F		Secondary FIRQ vector JMP+ address
SysTimeVal		EQU	$0112		Current value of system timer
BasRandomSeed		EQU	$0115		Random number seed for RND function
BasNumCmds		EQU	$0120		Number of basic commands
BasStub0		EQU	$0120		Basic Stub 0 (All basic on Dragon, Colour basic on Tandy)
BasAddrCmdList		EQU	$0121		Address of basic command list
BasAddrCmdDisp		EQU	$0123		Address of basic command dispatch
BasNumFuncs		EQU	$0125		Number of basic functions
BasAddrFuncList		EQU	$0126		Address of basic function list
BasAddrFuncDisp		EQU	$0128		Address of basic function dispatcher
BasNumDskCmds		EQU	$012A		Number of disk basic commands
BasStub1		EQU	$012A		Basic stub 1 (Disk basic on Dragon, Extended basic on Tandy)
BasAddrDskCmdList	EQU	$012B		Address of disk basic command list
BasAddrDskCmdDisp	EQU	$012D		Address of disk basic command dispatch
BasNumDskFuncs		EQU	$012F		Number of disk basic functions
BasAddrDskFuncList	EQU	$0130		Address of disk basic function list
BasAddrDskFuncDisp	EQU	$0132		Address of disk basic function dispatcher
BasUsrVecNoDisk		EQU	$0134		USR vector tabl when basic not installed
BasStub2		EQU	$0134		Basic Stub 2 (Null on dragon, Disk basic on Tandy)
BasStub3		EQU	$013E		Basic Stub 3 (do not use on dragon, user stub on Tandy)
TextPrnAutoCRLF		EQU	$0148		Printer auto EOL flag, nonzero will send EOL sequence at end of line
TextCapsLock		EQU	$0149		Capslock flag, nonzero=uppercase
TextPrnEOLCnt		EQU	$014A		Number of characters in EOL sequence 1..4
TextPrnEOLSeq		EQU	$014B		End of line characters
TextKbdRollover		EQU	$0150		Rollover table, to check for key releases
BasJoyVal0		EQU	$015A		Joystick(0) value
BasJoyVal1		EQU	$015B		Joystick(1) value
BasJoyVal2		EQU	$015C		Joystick(2) value
BasJoyVal3		EQU	$015D		Joystick(3) value
VectDevOpen		EQU	$015E		Called before a device is opened
VectBase		EQU	$015E		Base address of ram hooks/vectors
VectDevNo		EQU	$0161		Called when a device number is verified
VectDevInit		EQU	$0164		Called before initialising a device
VectOutChar		EQU	$0167		Called before outputting char in A to a device
VectInChar		EQU	$016A		Called before inputting a char to A
VectInputFile		EQU	$016D		Called before inputting from a file
VectOutputFile		EQU	$0170		Called before outputting to a file
VectCloseAllFiles	EQU	$0173		Called before closing all files
VectCloseFile		EQU	$0176		Called before closing a file
VectCmdInterp		EQU	$0179		Called before interpreting a token in A
VectReReqestIn		EQU	$017C		Called before re-requesing input from keyboard
VectCheckKeys		EQU	$017F		Called before keyboard is scanned for BREAK,SHIFT-@
VectLineInputFile	EQU	$0182		Called before LINE INPUT is executed
VectCloseFileCmd	EQU	$0185		Called before closing an ASCII file read in as basic
VectCheckEOF		EQU	$0188		called before checking for end of file
VectEvaluateExpr	EQU	$018B		Called before evaluating expression
VectUserError		EQU	$018E		Can be patched by user to trap error messages
VectSysError		EQU	$0191		Can be patched by system to trap error messages
VectRunLink		EQU	$0194		Called when RUN about to be executed
VectResetBasMem		EQU	$0197		Called before changing BASIC memory vectors after LOAD etc
VectGetNextCmd		EQU	$019A		Called before fetching next command to be executed by BASIC
VectAssignStr		EQU	$019D		Called before assigning string to string variable
VectAccessScreen	EQU	$01A0		Called before CLS, GET & PUT are executed
VectTokenize		EQU	$01A3		Called before an ASCII line is tokenized
VectDeTokenize		EQU	$01A6		Called before a line is de-tokenized
BasStrDescStack		EQU	$01A9		String descriptor stack
CasFNameLen		EQU	$01D1		Length of cassette filename can be 0 to 8
CasFName		EQU	$01D2		Cassete filename to search for or write out
CasFNameFound		EQU	$01DA		Filename found, when reading
CasIOBuff		EQU	$01DA		COS default IO buffer, if this contains filename block then folloing are valid
CasFType		EQU	$01E2		File type 0=tokenized basic, 1=ASCII data, 2=Binary
CasASCIIFlag		EQU	$01E3		ASCII flag byte
CasGapFlag		EQU	$01E4		Gap flag byte
CasEntryAddr		EQU	$01E5		Entry address for MC programs
CasLoadAddr		EQU	$01E7		Load address
BasLinInpHead		EQU	$02DA		Basic line input buffer header
BasLinInpBuff		EQU	$02DC		Basic line input buffer
BasBuffer		EQU	$03D7		Basic buffer space
TextSerEOLDelay		EQU	$03FD		End of line delay for serial port on Dragon 64 & CoCo
TextPrnSelFlag		EQU	$03FF		Dragon 64 printer selection flag, 0=paralell port, nonzero=RS232

;
; Ram hooks
;
;
; Some hooks share the same address, the only way to determine which is
; in use is to check the return address -- Source : "Inside the Dragon".
;

HookOpenDev	EQU		$15E		; Open device or file
HookCheckIONum	EQU		$161		; Check I/O device number
HookRetDevParam	EQU		$164		; Return device parameters
HookCharOut	EQU		$167		; Character output
HookCharIn	EQU		$16A		; Character input
HookCheckInput	EQU		$16D		; Deech dev open for input
HookCheckOutput	EQU		$170		; Deech dev open for output
HookCloseAll	EQU		$173		; Close all devices & files
HookCloseSingle	EQU		$176		; Close a single device or file
HookNewStat	EQU		$179		; About to dela with first char of new satement
HookDiskItem	EQU		$17C		; Disk file item scanner
HookPollBreak	EQU		$17F		; Poll for break key
HookReadInput	EQU		$182		; Read a line of input
HookFinishASCII	EQU		$185		; Finish loading ascii program
HookEOF		EQU		$188		; End of file function
HookEval	EQU		$18B		; Evaluate expression
HookUsrError	EQU		$18E		; User error trap
HookSysError	EQU		$191		; System error trap
HookRun		EQU		$194		; Run statement
HookStrCopy	EQU		$197		; String copy check
HookClear	EQU		$197		; Clear statement
HookFetchNext	EQU		$19A		; Fetch next statement
HookLet		EQU		$19D		; LET statement
HookCLS		EQU		$1A0		; CLS statement
HookRENUM	EQU		$1A0		; RENUM statment
HookPUTGET	EQU		$1A0		; PUT or GET statement
HookFunction	EQU		$1A0		; Function assignment
HookCompress	EQU		$1A3		; Compress basic line
HookExpand	EQU		$1A6		; Expand basic line for listing.

;
; Basic rom related stuff.
;

BasicHWInit	EQU		$8000		; Hardware initialisation
BasicSWInit	EQU		$8003		; Software initialisation
BasicKbdIn	EQU		$8006		; Keyboard input
BasicCursorB	EQU		$8009		; Cursor blink
BasicScreenOut	EQU		$800C		; Screen output
BasicPrintOut	EQU		$800F		; Printer output
BasicJoyIn	EQU		$8012		; Joystick input
BasicCassOn	EQU		$8015		; Cassette player motor on
BasicCassOff	EQU		$8018		; Cassette player motor off
BasicWriteLead	EQU		$801B		; Cassette write leader
BasicCassByOut	EQU		$801E		; Cassette byte output
BasicCassOnRd	EQU		$8021		; Cassette on for reading
BasicCassByIn	EQU		$8024		; Cassette byte input
BasicCassBitIn	EQU		$8027		; Cassette bit input
BasicSerIn	EQU		$802A		; Read a byte from serial
BasicSerOut	EQU		$802D		; Write a byte to serial port
BasicSetBaud	EQU		$8030		; Set baud rate

BasOMError	EQU		$8342		; ?OM error
CmdMode		EQU		$8371		; Go to basic command mode
BasResetStack	EQU		$8434		; Reset basic stack

VarGetExpr	EQU		$8877		; Get (and evaluate?) espression, addrss of expresion in $52
VarGetStr	EQU		$8887		; Get string variable from basic, and store it
VarCKComma	EQU		$89AA		; Check for comma 
BasSNError	EQU		$89B4		; ?SN ERROR basic routine
BasFCError	EQU		$8B8D		; ?FC Error basic routine
VarDelVar	EQU		$8D9F		; Delate a (tempory) var
VarGet8Bit	EQU		$8E51		; Get 8bit value
VarGet16Bit	EQU		$8E83		; Get 16 bit var from basic

TextOutCRLF	EQU		$90A1		; Output CRLF
BasPrintStr	EQU		$90E5		; Basic, print string.
TextOutQuestion	EQU		$90F8		; output a ?

BasicEntry	EQU		$B39B		; Basic entry point
BasicEntry2	EQU		$B3CE
BasicResetVec	EQU		$B3B4		; Basic rom reset vetcor

BasSignonMess	EQU		$B4B2		; Address of basic signon message

TextWaitKey	EQU		$B505		; Display cursor and await keypress

UtilCopyBXtoU	EQU		$B7CC		; copy B bytes from X to U

TextCls		EQU		$BA77		; Clear screen
SndDisable	EQU		$BAC3		; Disable (cassette) sound
SndDTOAOn	EQU		$BAED		; Turn on D to A sound
CasMotorOff	EQU		$BDDC		; Turn off casette motor
CasByteOut	EQU		$BE12		; Byte output to cassette
CasBitIn	EQU		$BDA5		; Reads a bity into the 'Z' flag
