REG_BASE			EQU	$ff50					; MMC reg base
D_CMD_REG			EQU	REG_BASE+CMD_REG		; command register
D_LATCH_REG			EQU	REG_BASE+LATCH_REG		; Latch register for command params
D_READ_DATA_REG		EQU REG_BASE+READ_DATA_REG	; Read data register for AVR->Dragon
D_WRITE_DATA_REG	EQU	REG_BASE+WRITE_DATA_REG ; Write data reg for Dragon->AVR

D_STATUS_REG		EQU	$ff54					; Status register.

STATUS_FLAG_BUSY	EQU	$01				; AVR Busy 
STATUS_FLAG_READ	EQU	$02				; AVR has read our byte
STATUS_FLAG_WRITTEN	EQU	$04				; AVR has written a byte

;
; The DragonMMC board includes a 32K static RAM chip that can be mapped into the
; $8000-$FFEF area, which is normally occupied by the system and cartrige ROMS.
; This is done so that the roms can be copied accross and patched for MMC use without
; having to have an overlay rom, containing a patched copy of the Dragon's ROM, 
; this way I don't end up having to distribute Microsoft owned code.
;

D_RAM_CTRL			EQU	$ff56			; RAM control reg

; D_RAM_CTRL bit encodings

D_RAM_ENABLE		EQU $01				; set to enable overlay ram, clear to disable
D_RAM_WP			EQU	$02				; set to write protect ram, clear to write enable
D_FIRQ_ENABLE		EQU	$04				; Enable routing of clock to FIRQ for cart auto-start

VarsBase			EQU	$600			; base of vars

;NewUsrVec	EQU	VarsBase+$00	; new USR vectors
NewUsrVec	EQU	$EC		; Unused if dos not present.

Dollar		EQU	'$'
BlkBegin	EQU	'<'		; Cassette block begin byte
SyncByte	EQU	'U'		; Cassette sync byte

; Offsets within file header, compatible with DragonDos/SuperDos
HdrID55		EQU		$00			; magic marker byte #1
HdrType		EQU		$01			; file type see filetypes below
HdrLoad		EQU		$02			; Load address of file
HdrLen		EQU		$04			; length of file
HdrExec		EQU		$06			; entry address of file
HdrIDAA		EQU		$08			; magic marker byte #2

FileHeadLen	EQU		$09

; File types

FTypeBas	EQU		$01			; Basic files
FTypeBin	EQU		$02			; Binary file types

; Tempory vars

CFGByte		EQU		BasUnused1	; put it in unused byte at $76
