;
; cmds_diskimg.asm
;
; Disk image manipulation.
;

CmdMDisk
	cmpa	#'I							; MDiskI ?
	beq		CmdMDiskI					; Yep insert
	
	cmpa	#'O							; MDiskO ?
	beq		CmdMdiskO					; Yep, eject
	
	cmpa	#'L							; MDiskL ?
	beq		CmdMdiskL					; Yep, list
	
	jmp		>BasSNError					; no : ?SN Error

;
; Insert a disk image into a virtual drive.
;

CmdMDiskI
	bsr		CmdDiskIOCommon				; get drive number and send it
	jsr     >VarCKComma					; Check for comma, error if not
	
	jsr		>GetSendFileName2			; get filename and send to AVR
	lda		#CMD_FILE_OPEN_IMG			; Open disk image
	jsr		>MMC_SendCmd				; Do it !
	jsr		>CheckError					; Check for error 
	
	clra
	rts

CmdDiskIOCommon
	jsr		<BasChrGet					; skip first char 		
	jsr		>VarGet8Bit					; Get drive no into b
	
	tfr		b,a							; get into a
	
	cmpa	#0							; less than 0 ?
	blo		CmdDiskFC					; yep : error
	cmpa	#4							; greater than 3 ?
	bhs		CmdDiskFC					; yep : error
	
	jsr		>MMC_InitSendBBytes			; Begin sending bytes to the AVR
	jmp		>MMC_WaitPutRead			; send the drive number
	
CmdDiskFC
	jmp		>BasFCError					; Generate FC error

;
; Eject a disk image from a virtual drive.
;
	
CmdMdiskO
	bsr		CmdDiskIOCommon				; get drive number and send it

	lda		#CMD_IMG_UNMOUNT			; Numount the image
	jsr		>MMC_SendCmd				; do it

	clra								; no error
	rts

;
; List mounted disks
;
	
CmdMDiskL
	jsr		<BasChrGet					; skip first char 		
	lda		#CMD_GET_IMG_NAME			; Get names of images
	jsr		>MMC_SendCmd				; do it
	jsr		>CheckError					; Check for error 

; If we get here, then we have the images names in the AVR data buffer
; we will read them back and display them

	lda		#CMD_INIT_READ				; start reading
	jsr		>MMC_SendCmd				; do it

	clrb								; name counter
	
CmdMDiskLNext
	pshs	b							; save it
	
	addb	#'0							; convert to ASCII
	tfr		b,a
	jsr		>BasicScreenOut				; print it
	
	lda		#':							; print :
	jsr		>BasicScreenOut				; print it
	
CmdMDiskLNextChar	
	jsr		>MMC_WaitGetWritten			; wait for a byte
	
	cmpa	#0							; end of name ?
	beq		CmdMDiskLEOL
	jsr		>BasicScreenOut				; print it
	bra		CmdMDiskLNextChar

CmdMDiskLEOL
	lbsr	CON_EOL						; send eol
	puls	b							; recover drive no
	
	incb								; increment
	cmpb	#4							; all done ?
	blo		CmdMDiskLNext				; nope do next 
	
	clra
	rts

	