;
; FTDI Vinculum defs.
;
; 2010-08-13, P.Harvey-Smith.
;

VincEOL		EQU	$0D		; EOL char
VincPrompt	EQU	'>'		; Vinculum prompt char

;
; Vinculum binary commands, used in SCS mode.
; All may be followed by parameters, and terminated with an EOL character
;

VCmdDIR		EQU	$01		; List files in directory
VCmdCD		EQU	$02		; Change directory
VCmdSD		EQU	$03		; Sector dump
VCmdRD		EQU	$04		; read a whole file
VCmdDLD		EQU	$05		; Delete a directory
VCmdMKD		EQU	$06		; Make a directory
VCmdDLF		EQU	$07		; Delete a file
VCmdWRF		EQU	$08		; Write data to a file
VCmdOPW		EQU	$09		; Open / Create a file for writing
VCmdCLF		EQU	$0A		; Close currently open file
VCmdRDF		EQU	$0B		; Read currently open file
VCmdREN		EQU	$0C		; Rename a file
VCmdOPR		EQU	$0E		; Open a file for reading
VCmdIDD		EQU	$0F		; Display information about the disk if disk is less than 4GB

VCmdSCS		EQU	$10		; Switch to short command (binary mode)
VCmdECS		EQU	$11		; Switch to short command (ascii mode)
VCmdFS		EQU	$12		; Return free space if free < 4GB
VCmdFWV		EQU	$13		; Get firmware version
VCmdSBD		EQU	$14		; Change monitor baud rate divisor
VCmdSUD		EQU	$15		; Suspend disk
VCmdWKD		EQU	$16		; Wake disk
VCmdSUM		EQU	$17		; Suspend monitor

VCmdSEK		EQU	$28		; Seek to a position in currently open file
VCmdIOR		EQU	$29		; Read I/O Port (1st parameter is port number)
VCmdIOW		EQU	$2A		; Write I/O Port (1st parameter is port number, 2nd is direction, 3rd is value)

VCmdDSN		EQU	$2D		; Display disk serial number
VCmdDVL		EQU	$2E		; Display disk volume label
VCmdDIRT	EQU	$2F		; List specified file and date and time of create, modify and file access

VCmdPGS		EQU	$81		; Printer get status
VCmdPSR		EQU	$82		; Printer soft reset

VCmdIPA		EQU	$90		; Command parameters / results in ASCII
VCmdIPH		EQU	$91		; Command parameters / results in binary (MSB first)
VCmdSW		EQU	$92		; Sector write
VCmdFSE		EQU	$93		; Return free space if free > 4GB
VCmdIDDE	EQU	$94		; Display information about the disk
VCmdFWU		EQU	$95		; Firmware upgrade

VCmdSyncU	EQU	'E'		; Echo E for syncronisation
VCmdSyncL	EQU	'e'		; Echo e for syncronisation


;
; Port numbers (1st param) for VCmdIOR and VCmdIOW
;

VPortAD		EQU	$00
VPortAC		EQU	$01
VPortBD		EQU	$02
VPortBC		EQU	$03
