;
; Console.asm : write things to Dragon screen.
;

CONWriteHexX
		pshs	d
		tfr		x,d
		bsr		ConWriteHexWordS	; Write x
		puls	d,pc
;
; Write hex word in D.
;

CONWriteHexWord
		pshs	d				; save d
		bsr		CONWriteHexByte	; Write MSB
		exg		a,b				; get LSB
		bsr		CONWriteHexByte	; Write LSB
		puls	d,pc			; restore / return
		
ConWriteHexWordS
		bsr		CONWriteHexWord	; Write word
		bra		CONWriteSpace	; write space
;
; Write byte in a as hex followed by space.
;
		
CONWriteHexByte
		pshs	a
	
		lsra					; Move msn to lsn
		lsra	
		lsra	
		lsra	

		bsr		CONGetHexNibbleA	; send msn
		jsr		BasicScreenOut	
	
		lda		,s				; retrive digit
		bsr		CONGetHexNibbleA	; send lsn
		jsr		BasicScreenOut	
		puls	a,pc

CONWriteHexByteS
		bsr		CONWriteHexByte	
		
CONWriteSpace
		pshs	a
		lda		#$20			; send space
		jsr		BasicScreenOut	; send it
		puls	a,pc
	
		
CONHexDigits
		fcc		/0123456789ABCDEF/
	
CONGetHexNibbleA
		pshs	x
		anda	#$0F			; mask out bytes
	
		leax	CONHexDigits,pcr	; Point to digits
		leax	a,x				; point to needed digit
		lda		,x				; **GET** hex digit !
		puls	x,pc

;
; Write a version number in a as msn.lsn followed by space.
;

CON_NdotN
		pshs	a
	
		lsra					; Move msn to lsn
		lsra	
		lsra	
		lsra	

		bsr		CONGetHexNibbleA ; send msn
		jsr		BasicScreenOut	

		lda		#'.				; send dot
		jsr		BasicScreenOut	

		lda		,s				 ; retrive digit
		bsr		CONGetHexNibbleA ; send lsn
		jsr		BasicScreenOut	
	
		lda		#$20			; send space
		jsr		BasicScreenOut	; send it
	
		puls	a,pc
		
;
; CON_EOL : Write end of line sequence
;

CON_EOL
		lda		#$0d			; EOL
		jmp		BasicScreenOut	; send it
		

CONWriteHexByteEOL
		pshs	a
		bsr		CONWriteHexByte
		bsr		CON_EOL
		puls	a
		rts
		
CON_WaitKey
		pshs	a
CON_WaitKeyLoop
		jsr		BasicKbdIn		
		beq		Con_WaitKeyLoop
		puls	a
		rts
		